#ifndef __HANDY_ARRAY_H__
#define __HANDY_ARRAY_H__

#include "handy.h"



template <class T>
class Array {
    T *_list;
    int _count;
public:
    Array(int capacity) : _count(capacity) {
        _list = new T[capacity];
    }
    Array(const Array& copy) {
        int capacity = copy.count();
        _list = new T[capacity];
        for (int i = 0; i < capacity; ++i) {
            _list[i] = copy[i];
        }
        _count = capacity;
    }
    ~Array() {
        delete[] _list;
        _list = nullptr;
    }



    bool out_of_range(int i) const {
        return (i < 0 || _count <= i);
    }
    int count() const {
        return _count;
    }



    T &operator [](int n) {
        if (out_of_range(n))
            throw Exception("Invalid range access");
        return _list[n];
    }
    const T &operator [](int n) const {
        if (out_of_range(n))
            throw Exception("Invalid range access");
        return _list[n];
    }
    Array &operator =(const Array& copy) {
        delete _list;
        int capacity = copy.count();
        _list = new T[capacity];
        for (int i = 0; i < capacity; ++i) {
            _list[i] = copy[i];
        }
        _count = capacity;
        return (*this);
    }
};

#endif