#ifndef __GRAPH_EDGE_H__
#define __GRAPH_EDGE_H__



class Edge {
    int _source;
    int _destination;
    int _cost;
public:
    Edge() : _source(-1), _destination(-1), _cost(-1) {}
    Edge(int src, int dst, int cost) : _source(src), _destination(dst), _cost(cost) {}



    int source() const { return _source; }
    void setSource(int value) { _source = value; }
    int destination() const { return _destination; }
    void setDestination(int value) { _destination = value; }
    int cost() const { return _cost; }
    void setCost(int value) { _cost = value; }



    bool operator !=(const Edge& edge) const {
        return !(*this == edge);
    }
    bool operator ==(const Edge& edge) const {
        if (_source == _destination && edge.source() == edge.destination()) {
            return true;
        }
        else if (_source == edge.source() && _destination == edge.destination()) {
            return true;
        }
        else if (_source == edge.destination() && _destination == edge.source()) {
            return true;
        }
        return false;
    }
    bool operator <(const Edge& edge) const {
        if (_source != edge.source()) {
            return (_source < edge.source());
        }
        else if (_destination != edge.source()) {
            return (_destination < edge.destination());
        }
        return _cost < edge.cost();
    }
    bool operator <=(const Edge& edge) const {
        return (*this < edge) || (*this == edge);
    }
};



int compareEdge(const Edge &edge1, const Edge &edge2);


#endif